
package org.mark.demo;

import java.util.ArrayList;
import java.util.List;
import java.util.concurrent.ThreadLocalRandom;

import org.slf4j.Logger;
import org.slf4j.LoggerFactory;
import org.springframework.context.annotation.Scope;
import org.springframework.stereotype.Component;

@Component("actor2")
@Scope("prototype")
public class Actor2 extends BaseActor {
    private static final Logger logger = LoggerFactory.getLogger(Actor2.class);

    @Override
    public void onReceive(Object message) throws Exception {
        Integer level = (Integer) message;
        //logger.info("Received message {}", level);
        if (level == 2) {
            logger.error("Received a message to itself");
        }

        List<Integer> list = new ArrayList<Integer>();
        if (level == 0) {
            list.add(1);
            list.add(3);
            list.add(5);
        } else {
            logger.error("Actor2. Unknown sender: {}", level);
        }
        

        int index = ThreadLocalRandom.current().nextInt(list.size());
        int numberOfChildren = 1000;
        for (int i = 1; i < numberOfChildren; i++) {
            int value = list.get(index);
            if (value == 2) {
                logger.error("Cannot send a message to itswelf");
            }

            String name = String.format("actor%d", value);
            //logger.info("Sending message # {} to a child {}", i, name);
            sendMessage(name, name, new Integer(2));

        }

    }

}
