package org.mark.demo;

import java.util.ArrayList;
import java.util.List;
import java.util.concurrent.ThreadLocalRandom;

import org.slf4j.Logger;
import org.slf4j.LoggerFactory;
import org.springframework.context.annotation.Scope;
import org.springframework.stereotype.Component;

@Component("actor5")
@Scope("prototype")
public class Actor5 extends BaseActor {
    private static final Logger logger = LoggerFactory.getLogger(Actor5.class);

    @Override
    public void onReceive(Object message) throws Exception {
        List<Integer> list = new ArrayList<Integer>();
        Integer level = (Integer) message;
        if (level == 5) {
            logger.error("Received a message to itself");
        }

        //logger.info("Received message {}", level);
        if (level == 1) {
            list.add(3);
            list.add(4);
        } else if (level == 2) {
            // final level
            return;
        }else {
            logger.error("Actor5. Unknown sender: {}", level);
        }

        int index = ThreadLocalRandom.current().nextInt(list.size() );
        int numberOfChildren = 1000;
        for (int i = 1; i < numberOfChildren; i++) {
            int value = list.get(index);
            if (value == 1) {
                logger.error("Cannot send a message to itswelf");
            }

            String name = String.format("actor%d", value);
            //logger.info("Sending message # {} to a child {}", i, name);
            sendMessage(name, name, new Integer(5));

        }

    }

}
