package org.mark.demo;

import org.springframework.beans.factory.annotation.Autowired;
import org.springframework.boot.SpringApplication;
import org.springframework.boot.autoconfigure.EnableAutoConfiguration;
import org.springframework.context.ConfigurableApplicationContext;
import org.springframework.context.annotation.Bean;
import org.springframework.context.annotation.ComponentScan;
import org.springframework.context.annotation.Configuration;

import com.typesafe.config.Config;
import com.typesafe.config.ConfigFactory;

import static org.mark.demo.SpringExtension.SpringExtProvider;



import akka.actor.ActorSystem;


@Configuration
@EnableAutoConfiguration
@ComponentScan(basePackages = { "org.mark.demo" })
public class AkkaDemo {
    

    
    @Autowired
    private ConfigurableApplicationContext applicationContext;

    
    @Bean
    public ActorSystem actorSystem() {

        ActorSystem system = null;
        system = ActorSystem.create("AkkaDemo", akkaConfiguration());

        // Initialize the application context in the Akka Spring Extension
        SpringExtProvider.get(system).initialize(applicationContext);
        return system;
    }

    @Bean
    public Config akkaConfiguration() {
        return ConfigFactory.load().getConfig("AkkaDemo");
    }
    
    

    public static void main(String[] args) {
        SpringApplication.run(AkkaDemo.class, args);

    }

}
