/*
 *  Copyright (c) 2016 EMC Corporation All Rights Reserved
 *
 *  This software contains the intellectual property of EMC
 *  Corporation or is licensed to EMC Corporation from third
 *  parties. Use of this software and the intellectual property
 *  contained therein is expressly limited to the terms and
 *  conditions of the License Agreement under which it is
 *  provided by or on behalf of EMC.
 */
package org.mark.demo;

import akka.actor.ActorSystem;
import org.springframework.beans.factory.annotation.Autowired;
import org.springframework.context.ApplicationContext;
import org.springframework.context.annotation.Bean;
import org.springframework.context.annotation.Configuration;
import static org.mark.demo.SpringExtension.SpringExtProvider;

/**
 * The application configuration.
 */
@Configuration
class AppConfiguration {

  // the application context is needed to initialize the Akka Spring Extension
  @Autowired
  private ApplicationContext applicationContext;

  /**
   * Actor system singleton for this application.
   */
  @Bean
  public ActorSystem actorSystem() {
    ActorSystem system = ActorSystem.create("AkkaJavaSpring");
    // initialize the application context in the Akka Spring Extension
    SpringExtProvider.get(system).initialize(applicationContext);
    return system;
  }
}