/*
 *  Copyright (c) 2016 EMC Corporation All Rights Reserved
 *
 *  This software contains the intellectual property of EMC
 *  Corporation or is licensed to EMC Corporation from third
 *  parties. Use of this software and the intellectual property
 *  contained therein is expressly limited to the terms and
 *  conditions of the License Agreement under which it is
 *  provided by or on behalf of EMC.
 */
package org.mark.demo;

import java.util.Random;

import org.slf4j.Logger;
import org.slf4j.LoggerFactory;
import org.springframework.context.annotation.Scope;
import org.springframework.stereotype.Component;

@Component("rootActor")
@Scope("prototype")
public class RootActor extends BaseActor {
    private static final Logger logger = LoggerFactory.getLogger(RootActor.class);
    
    private Random rand = new Random();

    @Override
    public void onReceive(Object message) throws Exception {
        Integer level = (Integer) message;
        //logger.info("Root actor received message with level {}", level);
        
        
        int numberOfChildren = rand.nextInt(1000);
        for (int i= 1; i < numberOfChildren; i++) {
            int actorNum = rand.nextInt((3 - 1) + 1) + 1;
            String name = String.format("actor%d", actorNum);
            //logger.info("Sending message # {} to a child {}", i, name);
            sendMessage(name, name, new Integer(0));
            
        }
            

    }

}
