
package org.mark.demo;

import akka.actor.Actor;
import akka.actor.IndirectActorProducer;
import org.springframework.context.ApplicationContext;

  
  public class SpringActorProducer implements IndirectActorProducer {
      final ApplicationContext applicationContext;
      final String actorBeanName;

      /**
       * 
       * @param applicationContext
       * @param actorBeanName
       */
      public SpringActorProducer(ApplicationContext applicationContext, String actorBeanName) {
          this.applicationContext = applicationContext;
          this.actorBeanName = actorBeanName;
      }

      /**
       * Bean producer. Instantiates actor from application context's bean NOTE: The actor classes must be declared as component with the "prototype"
       * scope
       */
      @Override
      public Actor produce() {
          return (Actor) applicationContext.getBean(actorBeanName);
      }

      @SuppressWarnings("unchecked")
      @Override
      public Class<? extends Actor> actorClass() {
          return (Class<? extends Actor>) applicationContext.getType(actorBeanName);
      }
}