package org.mark.demo;

import org.springframework.beans.factory.annotation.Autowired;
import org.springframework.stereotype.Controller;
import org.springframework.web.bind.annotation.RequestMapping;
import org.springframework.web.bind.annotation.RequestMethod;
import static org.mark.demo.SpringExtension.SpringExtProvider;

import akka.actor.ActorRef;
import akka.actor.ActorSystem;
import akka.routing.FromConfig;

@Controller
@RequestMapping("/start")
public class StartController {
    
    @Autowired
    private  ActorSystem system;
    
    private ActorRef rootActor;
    
    
    @RequestMapping(method = RequestMethod.POST)
    public String startTraversal() {
        if (rootActor == null) {
            rootActor = system.actorOf(SpringExtProvider.get(system).props("rootActor").withRouter(new FromConfig()),
                    "rootActor");
        }
        
        rootActor.tell(new Integer(0), null);
        return "traversal started";
    }
    

}
